<template>
  <section class="content">
    <Transition>
      <div v-if="username">
        <div class="avatar" :style="{ backgroundImage: `url(${avatarUrl})` }"></div>
        <h1>Ciao {{ username }}!</h1>
        <div class="mt-5">
          <h2>Aiutaci a rendere speciale il nostro giorno, carica le tue foto e i tuoi video!</h2>
        </div>

        <div id="button-elem-hook"></div>
        <div v-if="showPosts" class="bounce" @click="scrollToPosts">
          <svg xmlns="http://www.w3.org/2000/svg" height="1em" viewBox="0 0 448 512">
            <path
              d="M246.6 470.6c-12.5 12.5-32.8 12.5-45.3 0l-160-160c-12.5-12.5-12.5-32.8 0-45.3s32.8-12.5 45.3 0L224 402.7 361.4 265.4c12.5-12.5 32.8-12.5 45.3 0s12.5 32.8 0 45.3l-160 160zm160-352l-160 160c-12.5 12.5-32.8 12.5-45.3 0l-160-160c-12.5-12.5-12.5-32.8 0-45.3s32.8-12.5 45.3 0L224 210.7 361.4 73.4c12.5-12.5 32.8-12.5 45.3 0s12.5 32.8 0 45.3z"
            />
          </svg>
        </div>

        <label
          id="button-elem"
          class="button"
          for="file-select"
          :class="{ loading, 'top-fixed': isButtonTopFixed }"
        >
          <template v-if="!loading && !success">
            <svg xmlns="http://www.w3.org/2000/svg" height="1em" viewBox="0 0 512 512">
              <path
                d="M149.1 64.8L138.7 96H64C28.7 96 0 124.7 0 160V416c0 35.3 28.7 64 64 64H448c35.3 0 64-28.7 64-64V160c0-35.3-28.7-64-64-64H373.3L362.9 64.8C356.4 45.2 338.1 32 317.4 32H194.6c-20.7 0-39 13.2-45.5 32.8zM256 192a96 96 0 1 1 0 192 96 96 0 1 1 0-192z"
              />
            </svg>
            <span>Carica</span>
          </template>
          <TheLoader v-else-if="loading" :progress="loaderProgress" />
          <div v-else-if="success" class="success-icon">
            <svg xmlns="http://www.w3.org/2000/svg" height="1em" viewBox="0 0 512 512">
              <path
                d="M256 512A256 256 0 1 0 256 0a256 256 0 1 0 0 512zM369 209L241 337c-9.4 9.4-24.6 9.4-33.9 0l-64-64c-9.4-9.4-9.4-24.6 0-33.9s24.6-9.4 33.9 0l47 47L335 175c9.4-9.4 24.6-9.4 33.9 0s9.4 24.6 0 33.9z"
              />
            </svg>
          </div>
        </label>
        <input
          v-show="false"
          :disabled="loading || success"
          type="file"
          id="file-select"
          multiple
          accept="video/*,image/*"
          @change="filesSelected"
        />
      </div>
    </Transition>
    <div v-if="!username && !usernameNotFound">
      <svg class="welcome-loader" viewBox="25 25 50 50">
        <circle cx="50" cy="50" r="20" fill="none" stroke-width="6" stroke-miterlimit="10" />
      </svg>
    </div>
    <div v-else-if="usernameNotFound">
      <h1>Ciao!</h1>
      <div class="mt-5">
        <h2>Scannerizza il codice al tuo tavolo per iniziare!</h2>
      </div>
    </div>
  </section>
  <div v-if="showPosts" id="posts-elem" :class="{ 'mb-fill': posts.length < 2 }">
    <ThePosts :now="now" :posts="posts" :users="users" :admin="user.admin" />
  </div>
</template>

<script setup>
import { onMounted, ref, computed } from 'vue'
import { useRoute } from 'vue-router'
import { db, storage } from '@/firebase'
import { slugify } from '@/scripts/slugify'
import { generateVideoThumbnail } from '@/scripts/video'
import {
  doc,
  getDoc,
  collection,
  addDoc,
  serverTimestamp,
  onSnapshot,
  getDocs
} from 'firebase/firestore'
import {
  ref as storageReference,
  uploadBytesResumable,
  uploadString,
  getDownloadURL
} from 'firebase/storage'
import TheLoader from '@/components/TheLoader.vue'
import ThePosts from '@/components/ThePosts.vue'

const route = useRoute()
const loading = ref(false)
const progressAray = ref([])
const numberOfFiles = ref(0)
const error = ref(null)
const success = ref(false)
const isButtonTopFixed = ref(false)
const buttonOffset = ref(0)

const now = ref(new Date())
const users = ref([])
const posts = ref([])

const username = ref(null)
const avatarUrl = ref(null)
const user = ref(null)
const usernameNotFound = ref(false)

const showPosts = computed({
  get() {
    return posts.value.length > 0
  }
})

const loaderProgress = computed({
  get() {
    if (numberOfFiles.value === 0) {
      return 0
    }

    const overallProgress =
      numberOfFiles.value * 100 - progressAray.value.reduce((a, b) => a + b, 0)
    return Math.floor(100 - (overallProgress * 100) / (numberOfFiles.value * 100))
  }
})

onMounted(async () => {
  setTimeout(() => {
    const buttonElem = document.getElementById('button-elem-hook')

    if (!buttonElem) {
      return
    }

    window.addEventListener('scroll', () => {
      const offset = buttonElem.getBoundingClientRect().y

      if (offset === 0) {
        return
      }

      if (offset > buttonOffset.value && offset > 20) {
        // button is going down
        isButtonTopFixed.value = false
      } else if (offset < buttonOffset.value && offset < 20) {
        // button is going up
        isButtonTopFixed.value = true
      }

      buttonOffset.value = offset
    })
  }, 1000)

  const querySnapshot = await getDocs(collection(db, 'users'))
  querySnapshot.forEach((doc) => {
    users.value.push({
      ...doc.data(),
      id: doc.id
    })
  })

  const userId = route.params.userId

  if (!userId) {
    usernameNotFound.value = true
    return
  }

  const docRef = doc(db, 'users', userId)
  const docSnap = await getDoc(docRef)

  if (docSnap.exists()) {
    user.value = {
      ...docSnap.data(),
      id: docSnap.id
    }
    username.value = user.value.alias || user.value.name
    avatarUrl.value = user.value.avatar
    usernameNotFound.value = false
  } else {
    console.log('No such document!')
    username.value = null
    usernameNotFound.value = true
  }

  onSnapshot(collection(db, 'posts'), (snapshot) => {
    const newPosts = []
    snapshot.forEach((doc) => {
      const data = doc.data()
      newPosts.push({
        ...data,
        id: doc.id,
        user: users.value.find((u) => u.id === data.userId)
      })
      now.value = new Date()
    })

    posts.value = newPosts
  })

  setInterval(() => {
    now.value = new Date()
  }, 60000)
})

const scrollToPosts = () => {
  const top = document.querySelector('#posts-elem')?.offsetTop - 80
  window.scrollTo({
    behavior: 'smooth',
    top
  })
}

const uploadTaskPromise = async (file, index) => {
  return new Promise(function (resolve, reject) {
    const storageRef = storageReference(storage, `media/${slugify(user.value.name)}/${file.name}`)
    const uploadTask = uploadBytesResumable(storageRef, file)

    uploadTask.on(
      'state_changed',
      (snapshot) => {
        progressAray.value[index] = Math.floor(
          (snapshot.bytesTransferred / snapshot.totalBytes) * 100
        )
      },
      (err) => {
        reject(err)
      },
      () => {
        getDownloadURL(uploadTask.snapshot.ref).then((downloadURL) => {
          resolve(downloadURL)
        })
      }
    )
  })
}

const filesSelected = async (event) => {
  loading.value = true
  success.value = false
  let media = []

  try {
    numberOfFiles.value = event.target.files.length
    for (let i = 0; i < event.target.files.length; i++) {
      const file = event.target.files[i]

      const url = await uploadTaskPromise(file, i)

      const newMedia = {
        type: file.type,
        url
      }

      if (file.type?.toLowerCase()?.startsWith('video/')) {
        const thumbnailStorageRef = storageReference(
          storage,
          `media/${slugify(user.value.name)}/thumbnails/${slugify(file.name)}.png`
        )
        const thumbnailBase64 = await generateVideoThumbnail(file)
        const thumbnailSnapshot = await uploadString(
          thumbnailStorageRef,
          thumbnailBase64,
          'data_url'
        )
        newMedia.thumbnail = await getDownloadURL(thumbnailSnapshot.ref)
      }

      media = [...media, newMedia]
    }

    await addDoc(collection(db, 'posts'), {
      userId: user.value.id,
      timestamp: serverTimestamp(),
      media
    })

    success.value = true

    setTimeout(() => {
      scrollToPosts()
      setTimeout(() => {
        success.value = false
        numberOfFiles.value = 0
        progressAray.value = []
      }, 400)
    }, 600)
  } catch (e) {
    error.value = e
  } finally {
    loading.value = false
  }
}
</script>

<style lang="less" scoped>
.content {
  display: flex;
  flex-direction: column;
  justify-content: center;
  height: inherit;
  position: relative;
  margin: 0 2rem;
  height: 100vh;

  #button-elem-hook {
    margin-bottom: 48px;
  }

  .avatar {
    width: 120px;
    height: 120px;
    background-size: cover;
    background-repeat: no-repeat;
    border-radius: 500px;
    border: 4px solid var(--color-border-heading);
    margin-bottom: 15px;
  }

  .success-icon {
    animation: beat 0.3s cubic-bezier(0.8, 0, 0, 1) forwards;

    svg > path {
      fill: #fff;
    }

    svg {
      margin: 4px 6px 0;
      height: 30px;
    }
  }

  .top-fixed {
    position: fixed;
    z-index: 1;
    top: 8px;
    left: 70px;
    padding: 5px;
    height: 44px;
    width: 44px;

    svg {
      margin: 0;
    }

    span {
      display: none;
    }

    :deep(.the-loader) {
      margin: 4px;

      svg {
        display: none;
      }

      .progress {
        font-size: 15px;
        font-weight: 600;
      }
    }

    .success-icon {
      svg {
        margin: 10px 10px 0;
        height: 26px;
      }
    }
  }
}

.bounce {
  text-align: center;
  position: absolute;
  bottom: 100px;
  width: 100%;

  svg {
    height: 20px;

    path {
      fill: var(--color-text);
    }
  }
}

#posts-elem {
  max-width: 1024px;
  margin-bottom: 100px;
  margin: 0 1rem;
}

.v-enter-active,
.v-leave-active {
  transition: opacity 0.4s ease;
}

.v-enter-from,
.v-leave-to {
  opacity: 0;
}

.welcome-loader {
  animation: spinner-rotate 5332ms cubic-bezier(0.4, 0, 0.2, 1) infinite both;
  height: 50px;
  width: 50px;
  margin: auto;
  display: block;

  circle {
    stroke-dasharray: 1, 200;
    stroke-dashoffset: 0;
    animation: dash 1.5s ease-in-out infinite;
    stroke-linecap: round;
    stroke: var(--color-text);
  }
}
</style>
